using UnityEngine; 

namespace PPGHL
{
    public class PPGHL
    {
        public static void Main()
        {                         		                                    
            CategoryBuilder.Create("Hl2", "A category for half life two related things.", ModAPI.LoadSprite("Tab.png"));
  		    //Civil Protection Officer (CP)
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Civil Protection Officer (CP)-HL2", 
                    DescriptionOverride = "Civil Protection is the Combine's law enforcement in all urban areas on Earth.", 
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/CP Thumb.png"), 
                    AfterSpawn = (Instance) => 
                    {
          
                          var skin = ModAPI.LoadTexture("Sprites/CP.png");
                          var flesh = ModAPI.LoadTexture("Sprites/P Flesh.png");
                          var bone = ModAPI.LoadTexture("Sprites/P Bone.png");
    
                          var person = Instance.GetComponent<PersonBehaviour>();

            
                          person.SetBodyTextures(skin, flesh, bone, 1);

       
                          person.SetBruiseColor(86, 62, 130); 
                          person.SetSecondBruiseColor(154, 0, 7); 
                          person.SetThirdBruiseColor(207, 206, 120); 
                          person.SetRottenColour(202, 199, 104); 
                          person.SetBloodColour(108, 0, 4); 
                         	var head = Instance.transform.GetChild(5);
                       
 					      var cObj = new GameObject("head");
                          cObj.transform.SetParent(head);
                          cObj.transform.localPosition = new Vector3(0f, 0f);
                          cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                          cObj.transform.localScale = new Vector3(1f, 1f);
                          var cSpr = cObj.AddComponent<SpriteRenderer>();
                          cSpr.sprite = ModAPI.LoadSprite("Gasmask.png");
                          cSpr.sortingLayerName = "Top";
				    }
                }
            );
		    
		        //USP Match
 			    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("9mm Pistol"),
                    NameOverride = "USP Match-HL2",
                    NameToOrderByOverride = "F",
                    DescriptionOverride = "Used by CPs and rebels",
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/USP Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects();

                        var MakarovSlide = Instance.transform.Find("Slide");
                        MakarovSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/USPSlide.png");

                       
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/USP.png");

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.BulletsPerShot = 1;
                        firearm.barrelPosition = new Vector2(0f, 0f);
                        firearm.ShotSounds = new AudioClip[]
                        {
                              ModAPI.LoadSound("USP Shot.wav"),
                        };
		
		            }
                }
            );
		    //Civilain 01
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Civilain 01-HL2", 
                    DescriptionOverride = "A civilian.", 
                    CategoryOverride = ModAPI.FindCategory("Hl2"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Civilian 01.png"), 
                    AfterSpawn = (Instance) => 
                    {
                                  
                                    var skin = ModAPI.LoadTexture("Sprites/Civilian 01.png");
                                    var flesh = ModAPI.LoadTexture("blueFlesh.png");
                                    var bone = ModAPI.LoadTexture("blueBone.png");

                                   
                                    var person = Instance.GetComponent<PersonBehaviour>();
   
                                    
									person.SetBodyTextures(skin, flesh, bone, 1);

                                   
                                     person.SetBruiseColor(86, 62, 130);
                                     person.SetSecondBruiseColor(154, 0, 7); 
                                     person.SetThirdBruiseColor(207, 206, 120); 
                                     person.SetRottenColour(202, 199, 104); 
                                     person.SetBloodColour(108, 0, 4);
                      
					}
                }
            );
		    //Civilain 02
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Civilain 02-HL2", 
                    DescriptionOverride = "A civilian.", 
                    CategoryOverride = ModAPI.FindCategory("Hl2"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Civilian 02.png"), 
                    AfterSpawn = (Instance) => 
                    {
                                  
                                    var skin = ModAPI.LoadTexture("Sprites/Civilian 02.png");
                                    var flesh = ModAPI.LoadTexture("blueFlesh.png");
                                    var bone = ModAPI.LoadTexture("blueBone.png");

                                   
                                    var person = Instance.GetComponent<PersonBehaviour>();
   
                                    
									person.SetBodyTextures(skin, flesh, bone, 1);

                                   
                                     person.SetBruiseColor(86, 62, 130);
                                     person.SetSecondBruiseColor(154, 0, 7); 
                                     person.SetThirdBruiseColor(207, 206, 120); 
                                     person.SetRottenColour(202, 199, 104); 
                                     person.SetBloodColour(108, 0, 4);
                      
					}
                }
            );
		    //Rebel 01
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Rebel 01-HL2", 
                    DescriptionOverride = "A Rebel.", 
                    CategoryOverride = ModAPI.FindCategory("Hl2"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Rebel 01.png"), 
                    AfterSpawn = (Instance) => 
                    {
                                  
                                    var skin = ModAPI.LoadTexture("Sprites/Rebel 01.png");
                                    var flesh = ModAPI.LoadTexture("blueFlesh.png");
                                    var bone = ModAPI.LoadTexture("blueBone.png");

                                   
                                    var person = Instance.GetComponent<PersonBehaviour>();
   
                                    
									person.SetBodyTextures(skin, flesh, bone, 1);

                                   
                                     person.SetBruiseColor(86, 62, 130);
                                     person.SetSecondBruiseColor(154, 0, 7); 
                                     person.SetThirdBruiseColor(207, 206, 120); 
                                     person.SetRottenColour(202, 199, 104); 
                                     person.SetBloodColour(108, 0, 4);
                      
					}
                }
            );
		    //Rebel 02
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Rebel 02-HL2", 
                    DescriptionOverride = "A Rebel.", 
                    CategoryOverride = ModAPI.FindCategory("Hl2"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Rebel 02.png"), 
                    AfterSpawn = (Instance) => 
                    {
                                  
                                    var skin = ModAPI.LoadTexture("Sprites/Rebel 02.png");
                                    var flesh = ModAPI.LoadTexture("blueFlesh.png");
                                    var bone = ModAPI.LoadTexture("blueBone.png");

                                   
                                    var person = Instance.GetComponent<PersonBehaviour>();
   
                                    
									person.SetBodyTextures(skin, flesh, bone, 1);

                                   
                                     person.SetBruiseColor(86, 62, 130);
                                     person.SetSecondBruiseColor(154, 0, 7); 
                                     person.SetThirdBruiseColor(207, 206, 120); 
                                     person.SetRottenColour(202, 199, 104); 
                                     person.SetBloodColour(108, 0, 4);
                      
					}
                }
            );
		    //SMG
		    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), 
                    NameOverride = "SMG-HL2", 
                    NameToOrderByOverride = "f", 
                    DescriptionOverride = "Used by the combine and rebel forces.",
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/SMG Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
			        {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SMG.png");
                     Instance.FixColliders();
                       var firearm = Instance.GetComponent<FirearmBehaviour>();	                 
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("SMG shot.wav")
                        };
				    }
			    }
		    );
		    //Gravity Gun
		    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Physics Gun"), 
                    NameOverride = "Gravity Gun-HL2", 
                    NameToOrderByOverride = "f", 
                    DescriptionOverride = "Used to move objects.",
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Gravity Gun Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
			        {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Gravity Gun.png");
                     Instance.FixColliders();
                      
				    }
			    }
		    );
		    //Stunstick
		    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stunner"), 
                    NameOverride = "Stunstick-HL2", 
                    NameToOrderByOverride = "f", 
                    DescriptionOverride = "Used to beat or reeducate civilians.",
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Stunstick Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
			        {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Stunstick.png");
                     Instance.FixColliders();
                      
				    }
			    }
		    );
		    //Gordon Freeman
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Gordon Freeman-HL2", 
                    DescriptionOverride = "Do I even need to explain who this is?", 
                    CategoryOverride = ModAPI.FindCategory("Hl2"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Gordon Freeman Thumb.png"), 
                    AfterSpawn = (Instance) => 
                    {
                                  
                                    var skin = ModAPI.LoadTexture("Sprites/Gordon Freeman.png");
                                    var flesh = ModAPI.LoadTexture("blueFlesh.png");
                                    var bone = ModAPI.LoadTexture("blueBone.png");

                                   
                                    var person = Instance.GetComponent<PersonBehaviour>();
   
                                    
									person.SetBodyTextures(skin, flesh, bone, 1);

                                   
                                     person.SetBruiseColor(86, 62, 130);
                                     person.SetSecondBruiseColor(154, 0, 7); 
                                     person.SetThirdBruiseColor(207, 206, 120); 
                                     person.SetRottenColour(202, 199, 104); 
                                     person.SetBloodColour(108, 0, 4);
                      
					}
                }
            );
		    //Crowbar
		    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Crowbar-HL2", 
                    NameToOrderByOverride = "f", 
                    DescriptionOverride = "Used to beat or pry things open, also used by Gordon Freeman.",
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Crowbar Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
			        {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Crowbar.png");
                     Instance.FixColliders();
                      
				    }
			    }
		    );
		    //OTA Soldier
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "OTA Soldier-HL2", 
                    DescriptionOverride = "The next rank above CP, requires extreme body modifications.", 
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/OTA Soldier Thumb.png"), 
                    AfterSpawn = (Instance) => 
                    {
          
                          var skin = ModAPI.LoadTexture("Sprites/OTA Soldier.png");
                          var flesh = ModAPI.LoadTexture("Sprites/P Flesh.png");
                          var bone = ModAPI.LoadTexture("Sprites/P Bone.png");
    
                          var person = Instance.GetComponent<PersonBehaviour>();

            
                          person.SetBodyTextures(skin, flesh, bone, 1);

       
                          person.SetBruiseColor(86, 62, 130); 
                          person.SetSecondBruiseColor(154, 0, 7); 
                          person.SetThirdBruiseColor(207, 206, 120); 
                          person.SetRottenColour(202, 199, 104); 
                          person.SetBloodColour(108, 0, 4); 
                           
						     var head = Instance.transform.GetChild(5);
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                             gameObject1.transform.localScale = new Vector3(1f, 1f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("EYEBALL.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";
 					    
					      	 var cObj = new GameObject("head");
                             cObj.transform.SetParent(head);
                             cObj.transform.localPosition = new Vector3(0f, 0f);
                             cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             cObj.transform.localScale = new Vector3(1f, 1f);
                             var cSpr = cObj.AddComponent<SpriteRenderer>();
                             cSpr.sprite = ModAPI.LoadSprite("OTA Head.png");
                             cSpr.sortingLayerName = "Top";
				                      

				    }
                }
            );
		    //OTA Elite Soldier
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "OTA Elite Soldier-HL2", 
                    DescriptionOverride = "The next rank above OTA soldier, requires extreme body modifications.", 
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/OTA Elite Soldier Thumb.png"), 
                    AfterSpawn = (Instance) => 
                    {
          
                          var skin = ModAPI.LoadTexture("Sprites/OTA Elite Soldier.png");
                          var flesh = ModAPI.LoadTexture("Sprites/P Flesh.png");
                          var bone = ModAPI.LoadTexture("Sprites/P Bone.png");
    
                          var person = Instance.GetComponent<PersonBehaviour>();

            
                          person.SetBodyTextures(skin, flesh, bone, 1);

       
                          person.SetBruiseColor(86, 62, 130); 
                          person.SetSecondBruiseColor(154, 0, 7); 
                          person.SetThirdBruiseColor(207, 206, 120); 
                          person.SetRottenColour(202, 199, 104); 
                          person.SetBloodColour(108, 0, 4); 
                           
						     var head = Instance.transform.GetChild(5);
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                             gameObject1.transform.localScale = new Vector3(1f, 1f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("RED EYEBALL.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";
 					    
					      	 var cObj = new GameObject("head");
                             cObj.transform.SetParent(head);
                             cObj.transform.localPosition = new Vector3(0f, 0f);
                             cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             cObj.transform.localScale = new Vector3(1f, 1f);
                             var cSpr = cObj.AddComponent<SpriteRenderer>();
                             cSpr.sprite = ModAPI.LoadSprite("OTA Elite Head.png");
                             cSpr.sortingLayerName = "Top";
				                      

				    }
                }
            );
		    //Pulse Rifle
		    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("AK-47"), 
                    NameOverride = "Pulse Rifle-HL2", 
                    NameToOrderByOverride = "f", 
                    DescriptionOverride = "Used by the OTA.",
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Pulse Rifle Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
			        {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Pulse Rifle.png");
                     Instance.FixColliders();
                       var firearm = Instance.GetComponent<FirearmBehaviour>();	                 
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Pulse Rifle shot.wav")
                        };
				    }
			    }
		    );
	   	    //Spas 12
		    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"), 
                    NameOverride = "Spas 12-HL2", 
                    NameToOrderByOverride = "f", 
                    DescriptionOverride = "Used by the OTA.",
                    CategoryOverride = ModAPI.FindCategory("Hl2"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/Spas 12 Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
			        {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Spas 12.png");
                     Instance.FixColliders();
                       var firearm = Instance.GetComponent<FirearmBehaviour>();	                 
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Spas 12 shot.wav")
                        };
				    }
			    }
		    );
	    }
    }
}